require.config({
  paths: {
  'app': '../app'
  }
});

require([
  "underscore",
  "jquery",
  "splunkjs/mvc/utils",
  "splunkjs/mvc",
  "views/shared/results_table/renderers/BaseCellRenderer",
  "splunkjs/mvc/simplexml/ready!"
], function(_, $, utils, mvc, BaseCellRenderer) {
  require(["splunkjs/mvc/simplexml/ready!"], function () {

    var ActionCellRenderer = BaseCellRenderer.extend({

      canRender: function (cell) {
        return (cell.field === 'Actions'|| cell.field ==='Cribl Pipeline');
      },
      render: function ($td, cell) {
        // Actions comes in from search as savedSearchName
        if (cell.field === 'Actions') {
          const theSearch = cell.value;
          $td.addClass('action-cell').html(
                  '<div class="data-bar-wrapper" style="display:inline-block;"> ' +
                        '  <a id="edit_search" href="#" searchName="' + theSearch + '" class="action-col-button">Edit</a>' +
                        '</div> ' +
                        '<div class="data-bar-wrapper" style="display:inline-block;margin-left:10px;"> ' +
                        '  <a id="run_search" href="#" searchName="' + theSearch + '" class="action-col-button">Run</a> ' +
                        '</div>');
          $td.css('width', '120px');

          $td.find('#edit_search').on("click", function (e) {
            let searchName = $(this).attr("searchName");
            let url = '/manager/launcher/saved/searches?app=cribl&search=' + encodeURI(searchName);
            window.open(url, "_blank");
          });

          $td.find('#run_search').on("click", function (e) {
            let searchName = $(this).attr("searchName");
            let baseUrl = '/app/cribl/search?s=';
            let search = '/servicesNS/nobody/cribl/saved/searches/' + searchName;
            let url = baseUrl + encodeURIComponent(search);
            window.open(url, "_blank");
          });
        } else if (cell.field === 'Cribl Pipeline') {
          const theDescription = cell.value;
          const pipelineTokens = /pipeline\s([^ $]+)/.exec(theDescription);
          let pipelineName;
          if (pipelineTokens && pipelineTokens.length === 2) {
            pipelineName = pipelineTokens[1];
          }

          $td.addClass('pipeline-cell').html(
            '<div class="data-bar-wrapper" style="display:inline-block; text-align:left;"> ' +
            '  <a id="view_pipeline" href="#" pipelineName="' + pipelineName + '" class="action-col-button" >' + pipelineName + '</a>' +
            '</div> ');

          $td.find('#view_pipeline').on("click", function (e) {
            let pipelineName = $(this).attr("pipelineName");
            let url = 'https://' + window.location.hostname + ":9000/pipelines/" + pipelineName;
            window.open(url, "_blank");
          });
        }
      }
    });

    mvc.Components.get('saved_searches_table').getVisualization(function (tableView) {
      tableView.table.addCellRenderer(new ActionCellRenderer())
      tableView.table.render();
    });
  });
});
